precision mediump float;

varying vec2 uvCoords;
varying vec4 shadowCoord;
varying float lightingCoefficient;

uniform sampler2D texture;
uniform sampler2D shadowSampler;

void main()
{
	vec4 texel = texture2D(texture, uvCoords);
	//vec4 texel = texture2D(shadowSampler, uvCoords);

	vec4 shadowCoordinateWdivide = shadowCoord / shadowCoord.w;
	vec4 shadowTexel = texture2D(shadowSampler, shadowCoordinateWdivide.st); // texture unit 2 = shadowmap
	float distanceFromLight = shadowTexel.x + 0.003;

	vec4 pixelValues = vec4(texel.rgb * 0.3 + texel.rgb * 0.7 * lightingCoefficient, texel.a);

	float shadow = 1.0;
	if (shadowCoord.w > 0.0)
		shadow = distanceFromLight < shadowCoordinateWdivide.z ? 0.5 : 1.0;

	/*
	if (lightingCoefficient > 0.1)
		if (shadowCoordinateWdivide.s > 0.0)
			if (shadowCoordinateWdivide.t > 0.0)
				if (shadowCoordinateWdivide.s < 1.0)
					if (shadowCoordinateWdivide.t < 1.0)
					*/
					{
						pixelValues.r *= shadow;
						pixelValues.g *= shadow;
						pixelValues.b *= shadow;
					}

	gl_FragColor = pixelValues;

	//gl_FragColor = vec4(texel.rgb * 0.3 + texel.rgb * 0.7 * lightingCoefficient, texel.a);

	//gl_FragColor = vec4(0.0, 0.0, 1.0, 1.0);
	//gl_FragColor = shadowCoordinateWdivide;
}
